Subject: Re: bug#12911: 24.3.50; let users decide where (& perhaps whether) `emacs_backtrace.txt' files are written

From: Eli Zaretskii <[email-masked]>
Date: Mon, 19 Nov 2012 22:05:27 +0200

> From: Stefan Monnier <[email-masked]>
> Cc: [email-masked], [email-masked]
> Date: Mon, 19 Nov 2012 14:47:26 -0500
> 
> >> I don't know of any case under Unix where stderr is dumped into the
> >> great void
> > It can still scroll off the screen.  Or end up in some file that the
> > window-system developers or admins set up, and that is some random or
> > unknown place, as far as Emacs users and maintainers are concerned.
> > I see no significant difference.
> 
> The difference is that the above cases are hypothetical, whereas the w32
> case is the norm.

Neither is correct.  I just had the backtrace on GNU/Linux scroll off
on me (a TTY session crashed).  And I almost always invoke Emacs on
Windows in a way that leaves stderr output around.

But that is besides the point.  For J.R. Hacker who reads the manual,
what matters is what happens on her machine, not the statistical
average.  And what happens on her machine could well be that stderr
ends up in some random place on her disk.  As long as that is a real
possibility, writing emacs_backtrace.txt in the directory it is
written now on Windows is equivalent to what happens on Unix.  Making
it in ~/.emacs.d on w32 alone doesn't change the basic fact that most
of the users we care about will still have their backtraces in random
places.  Why not change that on all platforms?  Why demand that only
of w32?  For that matter, why do you care so much about w32 users?

> >> >> So let me reword my suggestion:
> >> >> I suggested to change the code such that, in those cases where we need
> >> >> to use emacs_backtrace.txt, we use ~/.emacs.d/backtrace.txt instead.
> >> > I already agreed to this, provided that Emacs puts stderr output there
> >> > on all platforms.
> >> Yes, on all platforms where emacs_backtrace.txt is needed (in practice,
> >> this does reduce to w32, AFAIK).
> > No, on _all_ platforms.
> 
> We disagree on the "is needed" part.

No, we disagree about the importance of uniformity in operation across
platforms.  Either the data is in a platform-specific place, in which
case the current arrangement is as good as any, or it is in the same
Emacs-specific place on all platforms.  The latter is the arrangement
I'd support and it will give me enough motivation to spend more effort
on this (although I'm not sure I have any energy left after this
longish discussion).